import { openBlock as n, createElementBlock as d, createElementVNode as l, renderSlot as r, computed as p, normalizeClass as b, unref as _, resolveComponent as k, createBlock as w, withCtx as h, withDirectives as x, isRef as B, vModelCheckbox as N, toDisplayString as c, createCommentVNode as v, ref as C, onMounted as q, Fragment as L, createVNode as S, withModifiers as $, createTextVNode as F, inject as V, vModelRadio as A, provide as D } from "vue";
const z = (s, t) => {
  const e = s.__vccOpts || s;
  for (const [o, a] of t)
    e[o] = a;
  return e;
}, R = {}, Z = { class: "cf-app-bar" };
function E(s, t) {
  return n(), d("header", Z, [
    l("div", null, [
      r(s.$slots, "left")
    ]),
    l("div", null, [
      r(s.$slots, "right")
    ])
  ]);
}
const P = /* @__PURE__ */ z(R, [["render", E]]);
const ct = {
  __name: "CfAppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(s) {
    const t = s, e = p(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": t.wide
    }));
    return (o, a) => (n(), d("div", {
      class: b(_(e))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
};
const T = ["type", "disabled"], ut = {
  __name: "CfButton",
  props: {
    to: {
      type: String,
      default: null
    },
    type: {
      type: String,
      default: "button"
    },
    large: {
      type: Boolean,
      default: !1
    },
    wide: {
      type: Boolean,
      default: !1
    },
    outlined: {
      type: Boolean,
      default: !1
    },
    color: {
      type: String,
      default: null
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    faux: {
      type: Boolean,
      default: !1
    }
  },
  setup(s) {
    const t = s, e = p(() => ({
      "cf-button": !0,
      "cf-button--outlined": t.outlined,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      [`cf-button--${t.color}`]: t.color,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled
    }));
    return (o, a) => {
      const i = k("router-link");
      return s.to ? (n(), w(i, {
        key: 0,
        class: b(_(e)),
        to: s.to
      }, {
        default: h(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to"])) : s.faux ? (n(), d("div", {
        key: 1,
        class: b(_(e))
      }, [
        r(o.$slots, "default")
      ], 2)) : (n(), d("button", {
        key: 2,
        class: b(_(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        r(o.$slots, "default")
      ], 10, T));
    };
  }
};
const U = { class: "cf-checkbox" }, G = ["id", "value", "true-value", "false-value", "disabled"], O = ["for"], j = {
  key: 0,
  class: "cf-checkbox__helper"
}, _t = {
  __name: "CfCheckbox",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    helper: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s, o = p({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    }), a = Math.random();
    return (i, f) => (n(), d("div", U, [
      x(l("input", {
        class: "cf-checkbox__input",
        "onUpdate:modelValue": f[0] || (f[0] = (g) => B(o) ? o.value = g : null),
        type: "checkbox",
        id: _(a),
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, G), [
        [N, _(o)]
      ]),
      l("div", null, [
        l("label", {
          class: "cf-checkbox__label",
          for: _(a)
        }, c(e.label), 9, O),
        e.helper ? (n(), d("div", j, c(e.helper), 1)) : v("", !0)
      ])
    ]));
  }
};
const H = { class: "cf-sidebar-nav" }, X = /* @__PURE__ */ l("hr", null, null, -1), J = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), K = /* @__PURE__ */ l("span", null, "Collapse sidebar", -1), Q = [
  J,
  K
], W = {
  __name: "CfSidebar",
  setup(s) {
    const t = C(!1), e = p(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (o, a) => (n(), d("aside", {
      class: b(_(e))
    }, [
      l("nav", H, [
        r(o.$slots, "default"),
        X
      ]),
      l("button", {
        class: "cf-sidebar-toggle",
        onClick: a[0] || (a[0] = (i) => t.value = !t.value)
      }, Q)
    ], 2));
  }
};
const ft = {
  __name: "CfDefaultLayout",
  setup(s) {
    return q(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (n(), d(L, null, [
      S(P, null, {
        left: h(() => [
          r(t.$slots, "brand")
        ]),
        right: h(() => [
          r(t.$slots, "navigation")
        ]),
        _: 3
      }),
      S(W, null, {
        default: h(() => [
          r(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      l("main", null, [
        r(t.$slots, "main")
      ])
    ], 64));
  }
};
const Y = { class: "cf-dialog-header" }, ee = { key: 0 }, te = { class: "cf-dialog-body" }, le = { class: "cf-dialog-footer" }, se = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), oe = [
  se
], pt = {
  __name: "CfDialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(s, { emit: t }) {
    const e = s, o = C(null);
    return q(() => o.value.showModal()), (a, i) => (n(), d("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: o
    }, [
      l("div", Y, [
        l("h1", null, c(e.title), 1),
        e.description ? (n(), d("div", ee, c(e.description), 1)) : v("", !0)
      ]),
      l("div", te, [
        r(a.$slots, "body")
      ]),
      l("div", le, [
        r(a.$slots, "footer")
      ]),
      l("button", {
        class: "cf-dialog-close",
        onClick: i[0] || (i[0] = (f) => t("close"))
      }, oe)
    ], 512));
  }
};
const ne = { class: "cf-dropdown-body" }, ae = {
  __name: "CfDropdown",
  setup(s) {
    const t = C(!1), e = p(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (o, a) => (n(), d("div", {
      class: b(_(e))
    }, [
      l("div", {
        class: "cf-dropdown-toggle",
        onClick: a[0] || (a[0] = (i) => t.value = !t.value)
      }, [
        r(o.$slots, "toggle")
      ]),
      l("div", ne, [
        r(o.$slots, "body")
      ]),
      l("div", {
        class: "cf-dropdown-backdrop",
        onClick: a[1] || (a[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const de = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, ie = { class: "material-symbols-outlined" }, re = { class: "cf-dropdown-item__label" }, ce = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, ue = { class: "material-symbols-outlined" }, _e = { class: "cf-dropdown-item__label" }, vt = {
  __name: "CfDropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(s) {
    const t = s, e = p(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (o, a) => {
      const i = k("router-link");
      return s.to ? (n(), w(i, {
        key: 1,
        class: b(_(e)),
        to: s.to
      }, {
        default: h(() => [
          s.icon ? (n(), d("div", ce, [
            l("span", ue, c(s.icon), 1)
          ])) : v("", !0),
          l("div", _e, [
            r(o.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (n(), d("button", {
        key: 0,
        class: b(_(e))
      }, [
        s.icon ? (n(), d("div", de, [
          l("span", ie, c(s.icon), 1)
        ])) : v("", !0),
        l("div", re, [
          r(o.$slots, "default")
        ])
      ], 2));
    };
  }
};
const fe = { class: "cf-drop-zone" }, pe = ["onDrop"], ve = { class: "cf-drop-zone-box__label" }, me = { class: "cf-drop-zone-box__action" }, be = /* @__PURE__ */ l("span", null, "select from device", -1), he = ["required"], ge = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, ye = {
  key: 1,
  class: "cf-drop-zone-list"
}, $e = /* @__PURE__ */ l("div", { class: "cf-drop-zone-list__header" }, null, -1), Ce = { class: "cf-drop-zone-list__item" }, Se = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), ke = [
  Se
], mt = {
  __name: "CfDropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "cancel"],
  setup(s, { emit: t }) {
    const e = s, o = C(null), a = p(() => !!(e.required && !e.modelValue)), i = p(() => {
      if (e.modelValue) {
        const u = (e.modelValue.size / 1048576).toFixed(0), M = (u / 1e3).toFixed(1);
        return u < 100 ? `${u} MB` : `${M} GB`;
      } else
        return "0 MB";
    }), f = (m) => {
      const u = m.target.files[0];
      y(u);
    }, g = (m) => {
      const u = m.dataTransfer.files[0];
      y(u);
    }, y = (m) => {
      const u = parseInt(e.max) * 1048576;
      u && u < m.size ? (o.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : t("update:modelValue", m);
    }, I = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (m, u) => (n(), d("div", fe, [
      s.modelValue ? (n(), d("div", ye, [
        $e,
        l("div", Ce, [
          l("div", null, c(e.modelValue.name), 1),
          l("div", null, c(_(i)), 1),
          l("button", { onClick: I }, ke)
        ])
      ])) : (n(), d("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: $(g, ["prevent"]),
        onDragenter: u[0] || (u[0] = $(() => {
        }, ["prevent"])),
        onDragover: u[1] || (u[1] = $(() => {
        }, ["prevent"])),
        onDragleave: u[2] || (u[2] = $(() => {
        }, ["prevent"]))
      }, [
        l("div", ve, c(e.label), 1),
        l("label", me, [
          F(" Drag and drop or "),
          be,
          l("input", {
            type: "file",
            ref_key: "input",
            ref: o,
            required: _(a),
            onChange: f
          }, null, 40, he)
        ]),
        e.max ? (n(), d("div", ge, " Files larger than " + c(e.max) + " MB cannot be uploaded ", 1)) : v("", !0)
      ], 40, pe))
    ]));
  }
};
const we = { class: "cf-input" }, xe = ["value", "type", "placeholder", "required", "disabled", "readonly"], Be = { class: "cf-input__label" }, Ve = {
  key: 0,
  class: "cf-input__helper"
}, bt = {
  __name: "CfInput",
  props: {
    modelValue: [Number, String],
    value: [Number, String],
    label: String,
    placeholder: String,
    helper: String,
    required: Boolean,
    disabled: Boolean,
    readonly: Boolean,
    type: {
      type: String,
      default: "text"
    }
  },
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s;
    return (o, a) => (n(), d("div", we, [
      l("input", {
        class: "cf-input__field",
        value: e.modelValue || e.value,
        type: e.type,
        placeholder: e.placeholder,
        required: e.required,
        disabled: e.disabled,
        readonly: e.readonly,
        onInput: a[0] || (a[0] = (i) => t("update:modelValue", i.target.value))
      }, null, 40, xe),
      l("label", Be, c(e.label), 1),
      e.helper ? (n(), d("div", Ve, c(e.helper), 1)) : v("", !0)
    ]));
  }
};
const De = {
  key: 0,
  class: "cf-nav-item"
}, Ne = { class: "cf-nav-item__label" }, qe = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ze = {
  key: 1,
  class: "cf-nav-item"
}, Ie = { class: "cf-nav-item__label" }, ht = {
  __name: "CfNavItem",
  props: {
    dropdown: Boolean
  },
  setup(s) {
    return (t, e) => s.dropdown ? (n(), d("div", De, [
      S(ae, null, {
        toggle: h(() => [
          l("div", Ne, [
            r(t.$slots, "default"),
            qe
          ])
        ]),
        body: h(() => [
          r(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (n(), d("button", ze, [
      l("div", Ie, [
        r(t.$slots, "default")
      ])
    ]));
  }
};
const Me = ["value", "max"], gt = {
  __name: "CfProgress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(s) {
    const t = s;
    return (e, o) => (n(), d("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, c(s.value) + "% ", 9, Me));
  }
};
const Le = { class: "cf-radio" }, Fe = ["id", "name", "value", "required", "disabled"], Ae = ["for"], Re = {
  key: 0,
  class: "cf-radio__helper"
}, yt = {
  __name: "CfRadio",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    helper: String,
    value: [Number, String, Boolean],
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s, o = Math.random(), a = {
      name: V("selection-name"),
      required: V("selection-required")
    }, i = p({
      get() {
        return e.modelValue;
      },
      set(f) {
        t("update:modelValue", f);
      }
    });
    return (f, g) => (n(), d("div", Le, [
      x(l("input", {
        class: "cf-radio__input",
        "onUpdate:modelValue": g[0] || (g[0] = (y) => B(i) ? i.value = y : null),
        type: "radio",
        id: _(o),
        name: a.name,
        value: e.value,
        required: a.required,
        disabled: e.disabled
      }, null, 8, Fe), [
        [A, _(i)]
      ]),
      l("div", null, [
        l("label", {
          class: "cf-radio__label",
          for: _(o)
        }, c(e.label), 9, Ae),
        e.helper ? (n(), d("div", Re, c(e.helper), 1)) : v("", !0)
      ])
    ]));
  }
};
const Ze = { class: "cf-select" }, Ee = ["value", "required", "disabled"], Pe = { class: "cf-select__label" }, Te = {
  key: 0,
  class: "cf-select__helper"
}, $t = {
  __name: "CfSelect",
  props: {
    modelValue: [Number, String],
    label: String,
    helper: String,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s;
    return (o, a) => (n(), d("div", Ze, [
      l("select", {
        class: "cf-select__field",
        value: e.modelValue,
        required: e.required,
        disabled: e.disabled,
        onInput: a[0] || (a[0] = (i) => t("update:modelValue", i.target.value))
      }, [
        r(o.$slots, "default")
      ], 40, Ee),
      l("label", Pe, c(e.label), 1),
      e.helper ? (n(), d("div", Te, c(e.helper), 1)) : v("", !0)
    ]));
  }
};
const Ue = ["inert"], Ge = {
  key: 0,
  class: "cf-selection-label"
}, Ct = {
  __name: "CfSelection",
  props: {
    label: String,
    disabled: Boolean,
    required: {
      type: Boolean,
      default: !1
    }
  },
  setup(s) {
    const t = s;
    return D("selection-name", Math.random()), D("selection-required", t.required), (e, o) => (n(), d("div", {
      class: "cf-selection",
      inert: s.disabled
    }, [
      s.label ? (n(), d("div", Ge, c(s.label), 1)) : v("", !0),
      r(e.$slots, "default")
    ], 8, Ue));
  }
};
const Oe = { class: "cf-sidebar-link__icon" }, je = { class: "material-symbols-outlined" }, He = { class: "cf-sidebar-link__label" }, Xe = ["href"], Je = { class: "cf-sidebar-link__icon" }, Ke = { class: "material-symbols-outlined" }, Qe = { class: "cf-sidebar-link__label" }, St = {
  __name: "CfSidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(s) {
    const t = s;
    return (e, o) => {
      const a = k("router-link");
      return s.to ? (n(), w(a, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: h(() => [
          l("div", Oe, [
            l("span", je, c(s.icon), 1)
          ]),
          l("div", He, [
            r(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (n(), d("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: s.href
      }, [
        l("div", Je, [
          l("span", Ke, c(s.icon), 1)
        ]),
        l("div", Qe, [
          r(e.$slots, "default")
        ])
      ], 8, Xe));
    };
  }
};
const We = {}, Ye = { class: "cf-spinner" }, et = /* @__PURE__ */ l("div", null, null, -1), tt = /* @__PURE__ */ l("div", null, null, -1), lt = /* @__PURE__ */ l("div", null, null, -1), st = /* @__PURE__ */ l("div", null, null, -1), ot = [
  et,
  tt,
  lt,
  st
];
function nt(s, t) {
  return n(), d("div", Ye, ot);
}
const kt = /* @__PURE__ */ z(We, [["render", nt]]);
const at = { class: "cf-switch" }, dt = ["value", "true-value", "false-value", "disabled"], it = {
  key: 0,
  class: "cf-switch__label"
}, wt = {
  __name: "CfSwitch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s, o = p({
      get() {
        return e.modelValue;
      },
      set(a) {
        t("update:modelValue", a);
      }
    });
    return (a, i) => (n(), d("div", at, [
      x(l("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (f) => B(o) ? o.value = f : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, dt), [
        [N, _(o)]
      ]),
      e.label ? (n(), d("div", it, c(e.label), 1)) : v("", !0)
    ]));
  }
};
export {
  P as CfAppBar,
  ct as CfAppBody,
  ut as CfButton,
  _t as CfCheckbox,
  ft as CfDefaultLayout,
  pt as CfDialog,
  mt as CfDropZone,
  ae as CfDropdown,
  vt as CfDropdownItem,
  bt as CfInput,
  ht as CfNavItem,
  gt as CfProgress,
  yt as CfRadio,
  $t as CfSelect,
  Ct as CfSelection,
  W as CfSidebar,
  St as CfSidebarLink,
  kt as CfSpinner,
  wt as CfSwitch
};
